<template>

    <div>
        <div class="d-flex justify-content-between mb-3">
            <div class="form-row">
                Show
                <select v-model="filter.entries" @change="changeEntries()">
                    <option value="10" selected>10</option>
                    <option value="25">25</option>
                    <option value="50">50</option>
                    <option value="75">75</option>
                    <option value="100">100</option>
                </select>
                entries
            </div>
            <div>
                <div class="spinner-border" role="status" v-show="isLoading">
                    <span class="sr-only">Loading...</span>
                </div>
            </div>
            <div>
                <input type="text" class="form-control form-control-sm" @input="isTyping = true" v-model="searchQuery" placeholder="Search ...">
            </div>
        </div>

        <table class="table table-hover">
            <thead>
                <tr>
                    <th v-for="column in columns" :width="column.width ? column.width+'%' : false">
                        {{column.title}}
                        <span class="show_as_link" v-if="column.sortable" @click="sort_method(column)">
                            <span v-show="column.sort_icon == 'no' "><i class="fas fa-sort"></i></span>
                            <span v-show="column.sort_icon == 'down' "><i class="fas fa-sort-down"></i></span>
                            <span v-show="column.sort_icon == 'up' "><i class="fas fa-sort-up"></i></span>
                        </span>
                    </th>
                </tr>
            </thead>
            <tbody>
                <tr v-for="row in rows">
                    <td v-for="column in columns" v-html="row[column.field]"></td>
                </tr>
            </tbody>
        </table>

        <pagination
            :total-pages="totalPages"
            :total="total"
            :per-page="filter.entries"
            :current-page="currentPage"
            @pagechanged="onPageChange"
        />

    </div>

</template>

<script>
    import _ from 'lodash';
    import pagination from './pagination.vue'

    export default {
        components: {
            pagination
        },
        props: ['route'],
        data(){
            return {
                columns:[],
                rows: [],
                currentPage: 1,
                total: 0,
                isLoading: false,
                searchQuery: "",
                isTyping: false,
                filter: {
                    'sort':null,
                    'sort_type':null,
                    'entries':10,
                    'skip':0,
                    'search':null,
                },
            }
        },
        computed: {
            // Calculate total page of pagination
            totalPages: function() {
                return Math.ceil(this.total / this.filter.entries)
            }
        },
        mounted(){
            this.getData(this.filter);
        },
        watch: {
            // Run search method after 1 second is typed
            searchQuery: _.debounce(function() {
                this.isTyping = false;
            }, 1000),
            isTyping: function(value) {
                if (!value) {
                    this.searchFilter(this.searchQuery);
                }
            }
        },
        methods: {
            // Change pagination method
            onPageChange(page) {
                this.currentPage = page;
                this.filter.skip = (page-1) * this.filter.entries;
                this.getData(this.filter);
            },
            // Sort method
            sort_method(column){
                this.filter.sort = (column.sort_field) ? column.sort_field : column.field;
                this.filter.sort_type = (this.filter.sort_type == 'asc') ? 'desc' : 'asc';
                for(let i in this.columns){
                    this.columns[i].sort_icon = 'no';
                }
                column.sort_icon = (this.filter.sort_type == 'asc') ? 'up' : 'down';
                this.getData(this.filter);
            },
            // When the entries number changes
            changeEntries(){
                this.currentPage = 1;
                this.filter.skip = 0;
                this.getData(this.filter);
            },
            // Run search text
            searchFilter(searchQuery){
                this.currentPage = 1;
                this.filter.skip = 0;
                this.filter.search = searchQuery;
                this.getData(this.filter);
            },
            // Get meta tag content
            getMeta(metaName) {
                const metas = document.getElementsByTagName('meta');

                for (let i = 0; i < metas.length; i++) {
                    if (metas[i].getAttribute('name') === metaName) {
                        return metas[i].getAttribute('content');
                    }
                }

                return '';
            },
            getData(filter){
                let vm = this;
                vm.isLoading = true;
                axios.post(vm.route, {
                    filter:filter,
                    _token: vm.getMeta('csrf-token'),
                })
                    .then(function(response){
                        vm.rows = response.data.rows;
                        vm.total = response.data.total;

                        if(vm.filter.sort == null){
                            vm.filter.sort = response.data.sort;
                            vm.filter.sort_type = response.data.sort_type;
                            vm.columns = response.data.columns;
                            for(let i in vm.columns){
                                if(vm.columns[i].field === vm.filter.sort || vm.columns[i].sort_field === vm.filter.sort){
                                    vm.columns[i].sort_icon = (vm.filter.sort_type == 'asc') ? 'up' : 'down';
                                } else {
                                    vm.columns[i].sort_icon = 'no';
                                }
                            }
                        }
                        vm.isLoading = false;
                    })
                    .catch(function (error) {
                        vm.$swal({
                            type: 'error',
                            title: 'خطا',
                            text: 'خطایی در سیستم ایجاد شده است، لطفا مجددا تلاش کنید',
                            timer: 5000,
                        });
                    });
            },
        }
    }
</script>
